// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Checker;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "GspellTextBuffer")]
    pub struct TextBuffer(Object<ffi::GspellTextBuffer, ffi::GspellTextBufferClass>);

    match fn {
        type_ => || ffi::gspell_text_buffer_get_type(),
    }
}

impl TextBuffer {
    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`TextBuffer`] objects.
    ///
    /// This method returns an instance of [`TextBufferBuilder`](crate::builders::TextBufferBuilder) which can be used to create [`TextBuffer`] objects.
    pub fn builder() -> TextBufferBuilder {
        TextBufferBuilder::new()
    }

    #[doc(alias = "gspell_text_buffer_get_buffer")]
    #[doc(alias = "get_buffer")]
    pub fn buffer(&self) -> Option<gtk::TextBuffer> {
        unsafe { from_glib_none(ffi::gspell_text_buffer_get_buffer(self.to_glib_none().0)) }
    }

    #[doc(alias = "gspell_text_buffer_get_spell_checker")]
    #[doc(alias = "get_spell_checker")]
    pub fn spell_checker(&self) -> Option<Checker> {
        unsafe {
            from_glib_none(ffi::gspell_text_buffer_get_spell_checker(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "gspell_text_buffer_set_spell_checker")]
    pub fn set_spell_checker(&self, spell_checker: Option<&impl IsA<Checker>>) {
        unsafe {
            ffi::gspell_text_buffer_set_spell_checker(
                self.to_glib_none().0,
                spell_checker.map(|p| p.as_ref()).to_glib_none().0,
            );
        }
    }

    #[doc(alias = "gspell_text_buffer_get_from_gtk_text_buffer")]
    #[doc(alias = "get_from_gtk_text_buffer")]
    pub fn from_gtk_text_buffer(gtk_buffer: &impl IsA<gtk::TextBuffer>) -> Option<TextBuffer> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_none(ffi::gspell_text_buffer_get_from_gtk_text_buffer(
                gtk_buffer.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "spell-checker")]
    pub fn connect_spell_checker_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_spell_checker_trampoline<F: Fn(&TextBuffer) + 'static>(
            this: *mut ffi::GspellTextBuffer,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::spell-checker\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_spell_checker_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`TextBuffer`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct TextBufferBuilder {
    builder: glib::object::ObjectBuilder<'static, TextBuffer>,
}

impl TextBufferBuilder {
    fn new() -> Self {
        Self {
            builder: glib::object::Object::builder(),
        }
    }

    pub fn buffer(self, buffer: &impl IsA<gtk::TextBuffer>) -> Self {
        Self {
            builder: self.builder.property("buffer", buffer.clone().upcast()),
        }
    }

    pub fn spell_checker(self, spell_checker: &impl IsA<Checker>) -> Self {
        Self {
            builder: self
                .builder
                .property("spell-checker", spell_checker.clone().upcast()),
        }
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`TextBuffer`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> TextBuffer {
        self.builder.build()
    }
}

impl fmt::Display for TextBuffer {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("TextBuffer")
    }
}
